UPs des 192K-Moduls

00 PRNA , Ausgabe Register A zum Bildschirm
01 PRNZ , Ausgabe Register A als ASCII-Zeichen zum Bildschirm (00-1F als '.')
02 PRNSP, Ausgabe ein Leerzeichen
04 PRNDE, Ausgabe von 2 Zeichen. aus D und E
05 PCRLF, Ausgabe Zeilenschaltung (0DH, 0AH)
06 PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
07 PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
08 PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
09 PRST , Ausgabe Zeichenkette ab (HL), Zeichenzahl in B
0A PRCST, Ausgabe Zeichenkette ob (DE) bis zum Code 00 (fr Fehlermeldungen)
0B DISPO, Anzeige eines Speicherbereiches hexadezimal und ASCII von (HL) bis (DE)
0C PRNER, Systemfehleranzeige, A=Fehlercode, B=Zusatzinformation
0D PRDEZ, Ausgabe Register HL Dezimal (5 Zeichen)
10 INBY , Eingabe 1 Byte hexadezimal in E   R:A=1 leer / A=2 falsch / A=3 OK
11 INAD , Eingabe Adresse hexadezimal in DE   R:A=1 leer / A=2 falsch / A=3 OK
12 INSTR, Eingabe Zeichenkette ob (HL), B=Lnge, C=Bank
13 PAUSE, Tastatureingabe PAUSE, CONT, STOP auswerten
14 INZIF, Eingabe 1 Byte mit Aufforderungstext
15 INZIA, Eingabe Adresse mit Aufforderungstext
16 INPUT, Eingabe Zeichenkette mit Aufforderungstext
17 INPDA, Eingabe 1 Byte mit Aufforderungstext und Anzeige des vorgegebenen Wertes
18 STENT, Tastatureingabe STOP, ENTER auswerten
19 PARH2, 1 Byte hexadezimal aus Kommandozeile in Register E holen
1A PARB2, 2 Byte hex. aus Kommandozeile holen, 1.Byte in L, 2.Byte in H u. E
1B PARDB, 1 Byte dezimal aus Kommandozeile in E holen
1C PARDA, 1 Adresse dezimal aus Kommandozeile in DE holen
1D PARH4, 1 Adresse hexadezimal aus Kommandozeile in DE holen
1E PARA2, 2 Adressen hexadezimal aus Kommandozeile in HL und DE holen
1F PARA3, 3 Adressen hexadezimal aus Kommandozeile in HL, DE und BC holen
20 ASHEX, '0' ... 'F' in 30...3F umwandeln
21 NUMP , Byte aus A in 2 ASCII-Zeichen in DE umwandeln
23 DADBC, BCD-Addition 8 Tetraden DEHL:=DEHL+BC
28 NPAR , 2 Parameter aus Kommandozeile ab 80H als Dateibezeichnung in FCB ab (5C)
29 PARA , Parameter ab (DE) als Dateibezeichnung interpretieren und ab (HL) eintr.
2A KMOVE, 1. Parameter der Kommandozeile (DE) wegschieben
2B HEXDU, Umwandlung Zeichenkette (z.B.'F123H') in HEX-Zahl in DE
2C DEZDU, Umwandlung Zeichenkette (z.B.'0123') in Dezimalzahl in DE
30 CONSI, Eingabe von Console (Tastatur)
31 STCON, Statusabfrage Console (Tastaturstatus)
32 CONO , Ausgabe zu Console (Bildschirm)
33 CONSO, Ausgabe zu Console und evtl. zum Drucker.
34 READI, Eingabe vom Reader
35 STRDR, Statusabfrage Reader
36 OPRDR, OPEN Reader
37 CLRDR, CLOSE Reader
38 PUNO , Ausgabe zu Punch
39 STPUN, Statusabfrage Punch
3A OPPUN, OPEN Punch
3B CLPUN, CLOSE Punch
3C LISTO, Ausgabe zu List
3D STLST, Statusabfrage List
3E OPLST, OFEN List
3F CLLST, CLOSE List
40 R1   , 1 Byte von (HL) Bank (A) in A lesen
41 R3   , 3 Byte von (HL) (A) in E, D, H lesen
42 W1   , 1 Byte aus E auf (HL) in Bank (A) schreiben
43 W2   , 2 Byte aus E, D auf (HL) (A) schreiben
44 LDIRU, Blocktransport zwischen Bnken von (HL) (B) nach (DE) (C), Lnge = IX
45 CPROM, Kommandoname in allen Bnken suchen
46 LDDRU, Blocktransport rckwrts (entspricht LDDR), Register wie LDIRU
70 CTTY , CON - TTY - Gert
71 CCRT , CON - CRT - Gert (Bildschirm und Tastatur)
72 CBAT , CON - BAT - Gert
73 CUC1 , CON - UC1
74 RTTY , RDR - ITY
75 RPTR , RDR - PTR
76 RUR1 , ROR - UR1
77 RUR2 , RDR - UR2
78 PTTY , PUN - TTY
79 PPTP , PUN - PTP
7A PUP1 , PUN - UP1
7B PUP2 , PUN - UP2
7C LTTY , LST - TTY
7D LCRT , LST - CRT
7E LLPT , LST - LPT - Gert (Drucker)
7F LUL1 , LST - UL1
80 BOOT , BIOS-Ruf 0 Kaltstart
81 WBOOT, BIOS-Ruf 1 Warmstart
82 STCON, BIOS-Ruf 2 Status Console Eingabe
83 CONSI, BIOS-Ruf 3 Eingabe Console
84 CONO , BIOS-Ruf 4 Ausgabe Console
85 LISTO, BIOS-Ruf 5 Ausgabe List
86 PUNO , BIOS-Ruf 6 Ausgabe Punch
87 READI, BIOS-Ruf 7 Eingabe Reader
88 HOME , BIOS-Ruf 8 Rcksetzen Diskettensystem
89 SELDS, BIOS-Ruf 9 Auswahl Laufwerk
8A SETTR, BIOS-Ruf 10 Auswahl Spur
8B SETSE, BIOS-Ruf 11 Auswahl Sektor
8C SETDM, BIOS-Ruf 12 Festlegen DMA-Adresse, die Bank wird auf 0FFH gesetzt
8D READ , BIOS-Ruf 13 Lesen eines 128 Byte Sektors von Diskette auf die DMA-Adresse
8E WRITE, BIOS-Ruf 14 Schreiben eines 128 Byte Sektors out Diskette
8F STLST, BIOS-Ruf 15 Status List
90 SECT , BIOS-Ruf 16 Sektortranslate
91 STCON, BIOS-Ruf 17 Status Console Ausgabe
92 STRDR, BIOS-Ruf 18 Status Reeder
93 STPUN, BIOS-Ruf 19 Status Punch
94 SETDB, Festlegen der Bank zur DMA-Adresse
FF EXTUP, Einbindung eines weiteren Unterprogrammes in das System UP
