;------------------------------------------------------------------------------
; CCP - Kommandointerpreter
;------------------------------------------------------------------------------

;		org	0D100h

		jp	cmd_i_ccp
aCcp:		db "$CCP    "
		db 0
		jp	cmd_bo_ccpk
aCcpk_0:	db "#CCPK   "
		db 0
		jp	cmd_bo_ccpw
aCcpw_0:	db "#CCPW   "
		db 0
		jp	cmd_load
aLoad:		db "LOAD    "
		db 0
		jp	cmd_go
aGo:		db "GO      "
		db 0
		jp	cmd_bank
		db "^       "
		db 0
		db 0

;------------------------------------------------------------------------------
; Kommando #CCPK
; Aufruf: durch BO (Abschlu Kaltstartinitialisierung)
;------------------------------------------------------------------------------

cmd_bo_ccpk:	nop
		jr	cmd_bo_ccpw1

;------------------------------------------------------------------------------
; #CCPW
; Aufruf: durch BO (Abschlu Warmstartinitialisierung)
;------------------------------------------------------------------------------

cmd_bo_ccpw:	nop
cmd_bo_ccpw1:	ld	sp, 200h
		ld	hl, sub_goret7
		push	hl
		ld	a, (sys_bank)
		or	0Fh
		ld	(sys_bank), a
		out	(0FFh),	a
		ei
		rst	20h
		db 5h				; PCRLF, Ausgabe Zeilenschaltung (0DH, 0AH)
		ret	c			; bei Fehler
		ld	a, '%'
		rst	20h
		db 0h				; PRNA , Ausgabe Register A zum Bildschirm
		ret	c			; bei Fehler
		ld	de, 7Fh
		push	de
		ld	a, 7Eh
		ld	(de), a
		ld	c, 0Ah
		rst	8			; BDOS-Ruf 10: Eingabe in Konsolenbuff34
		pop	de
		jr	nc, cmd_bo_ccpw2
		or	a
		ret	nz
		jp	0
cmd_bo_ccpw2:	inc	de
		ld	a, (de)
		ld	b, a
		inc	de
		ld	l, e
		ld	h, d
		or	a
		jr	z, cmd_bo_ccpw4
cmd_bo_ccpw3:	ld	a, (hl)
		call	loc_0_D380
		ld	(hl), a
		inc	hl
		djnz	cmd_bo_ccpw3
cmd_bo_ccpw4:	ld	(hl), b
		ld	hl, fcb1
		call	sub_para
		jp	c, loc_0_D35C
		jp	nz, loc_0_D35C
		ld	a, (fcb1)
		or	a
		jr	nz, cmd_bo_ccpw5
		ld	de, fcb1+1		; FNAME
		ld	a, (de)
		cp	' '
		jr	z, cmd_bo_ccpw1
		ld	bc, 0E700h
		ld	l, 0FFh
		rst	20h
		db 45h				; CPROM, Kommandoname in allen Bnken suchen
		ret	c			; bei Fehler
		ex	de, hl
		jr	z, cmd_bo_ccpw6
cmd_bo_ccpw5:	ld	c, 8Ch
		rst	8			; BDOS-Ruf 8Ch
		ret	c			; bei Fehler
		ld	a, 0FFh
cmd_bo_ccpw6:	ld	b, a
		call	sub_npar
		jp	c, loc_0_D35C
		ld	a, b
		jp	cmd_go10

;------------------------------------------------------------------------------
; 100% CP/M-Modus (?)
; Aufruf: GO
;------------------------------------------------------------------------------

cmd_go:		di
		ld	a, (sys_bank)
		or	0Fh
		ld	(sys_bank), a
		out	(0FFh),	a
		ld	hl, 0E600h
		ld	de, 100h
		ld	bc, 100h
		xor	a
cmd_go1:	ldi
		dec	hl
		ld	(hl), a
		inc	hl
		jp	pe, cmd_go1
		
		ld	bc, 100h
cmd_go2:	ld	a, (de)
		ldi
		dec	hl
		ld	(hl), a
		inc	hl
		jp	pe, cmd_go2
		
		ld	a, (sys_bank)
		or	0Fh
		ld	d, a
		and	0F0h
		or	0Eh
		ld	e, a
		ld	c, 0FFh
		ld	ix, 0E600h
		ld	hl, 1C0h
cmd_go3:	out	(c), d
		ld	a, (ix+0)
		out	(c), e
		ld	(ix+0),	a
		inc	ix
		dec	hl
		ld	a, l
		or	h
		jr	nz, cmd_go3
		
		ld	h, 7
cmd_go4:	out	(c), d
		ld	a, (ix+0)
		out	(c), e
		ld	(ix+0),	a
		inc	ix
		out	(c), d
		ld	a, (ix+0)
		out	(c), e
		ld	(ix+0),	a
		inc	ix
		cp	3Eh
		out	(c), d
		ld	a, (ix+0)
		out	(c), e
		ld	(ix+0),	a
		jr	nz, cmd_go5
		and	0Fh
		ld	b, a
		ld	a, d
		and	0Fh
		cp	b
		jr	nz, cmd_go5
		ld	a, (ix+0)
		and	0F0h
		ld	b, a
		ld	a, e
		and	0Fh
		or	b
		ld	(ix+0),	a
cmd_go5:	inc	ix
		ld	b, 6
cmd_go6:	out	(c), d
		ld	a, (ix+0)
		out	(c), e
		ld	(ix+0),	a
		inc	ix
		djnz	cmd_go6
		dec	h
		jr	nz, cmd_go4
		
		out	(c), d
		ld	a, (ix+0)
		out	(c), e
		ld	(ix+0),	a
		ld	hl, 0E203h		; ?
		ld	(1), hl
		ld	a, (4)
		ld	b, a
		ld	a, (3)
		ld	(4), a
		ld	a, b
		ld	(3), a
		ld	hl, bdos_10_7		; ????
		ld	(6), hl
		ld	hl, 8
		ld	de, 6
		ld	c, 0C0h
		ld	b, 7
cmd_go7:	ld	a, 0C3h
		cp	(hl)
		inc	hl
		jr	nz, cmd_go8
		ld	a, c
		cp	(hl)
cmd_go8:	inc	hl
		jr	nz, cmd_go9
		ld	a, i
		cp	(hl)
		jr	nz, cmd_go9
		ld	(hl), 0E7h
cmd_go9:	add	hl, de
		ld	a, c
		add	a, 9
		ld	c, a
		djnz	cmd_go7
		ld	a, (sys_bank)
		or	0Fh
		ld	(sys_bank), a
		out	(0FFh),	a
		ld	a, 0E7h
		ld	i, a
		ld	sp, 0E700h
		ei
		ld	hl, 100h
		ld	a, 0FFh
cmd_go10:	ex	de, hl
		ld	hl, sub_goret
		push	hl
		ld	hl, sys_bank
		ld	h, (hl)
		push	hl
		ld	hl, sys_rst20ret
		push	hl
		ex	de, hl
		jp	sys_jphl
;
;
;
sub_goret:	di
		ex	af, af'
		ld	a, i
		cp	2
		jr	z, sub_goret6

		exx
		ld	a, (sys_bank)
		or	0Fh
		ld	(sys_bank), a
		out	(0FFh),	a
		ld	hl, 100h
		ld	de, 0E600h
		ld	bc, 100h
		xor	a

sub_goret1:	ldi
		dec	hl
		ld	(hl), a
		inc	hl
		jp	pe, sub_goret1

		ld	bc, 100h

sub_goret2:	ld	a, (de)
		ldi
		dec	hl
		ld	(hl), a
		inc	hl
		jp	pe, sub_goret2

		ld	hl, sys_wboot
		ld	(1), hl
		ld	a, (3)
		ld	b, a
		ld	a, (4)
		ld	(3), a
		ld	a, b
		ld	(4), a
		ld	hl, 0F314h		; Z9001-System-BOS
		ld	(6), hl
		ld	hl, 8
		ld	de, 6
		ld	c, 0C0h
		ld	b, 7

sub_goret3:	ld	a, 0C3h
		cp	(hl)
		inc	hl
		jr	nz, sub_goret4

		ld	a, c
		cp	(hl)

sub_goret4:	inc	hl
		jr	nz, sub_goret5

		ld	a, i
		cp	(hl)
		jr	nz, sub_goret5

		ld	(hl), 2

sub_goret5:	add	hl, de
		ld	a, c
		add	a, 9
		ld	c, a
		djnz	sub_goret3

		ld	a, 2
		ld	i, a
		exx

sub_goret6:	ld	sp, 200h
		ex	af, af'
		ei
		jr	nc, sub_goret8


sub_goret7:	rst	20h
		db 0Ch				; PRNER, Systemfehleranzeige, A=Fehlercode, B=Zusatzinformation
		jr	nc, sub_goret8

		ld	a, standard_bank
		ld	hl, WBOOT
		di
		jp	sys_jphl


sub_goret8:	jp	cmd_bo_ccpw1


;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

loc_0_D35C:	ld	de, CONBU+1
loc_0_D35F:	ld	a, (de)
		inc	de
		or	a
		jr	z, loc_0_D375
		cp	' '
		jr	z, loc_0_D35F
loc_0_D368:	rst	20h
		db 1h				; PRNZ , Ausgabe Register A als ASCII-Zeichen zum Bildschirm (00-1F als '.')
		jr	c, sub_goret7
		ld	a, (de)
		inc	de
		or	a
		jr	z, loc_0_D375
		cp	20h
		jr	nz, loc_0_D368
loc_0_D375:	ld	d, ' '
		ld	e, '?'
		rst	20h
		db 4h				; PRNDE, Ausgabe von 2 Zeichen. aus D und E
		jr	c, sub_goret7
		jp	cmd_bo_ccpw1

loc_0_D380:	cp	'a'
		ret	c			; bei Fehler
		cp	'z'+1
		ret	nc
		and	5Fh
		ret

;------------------------------------------------------------------------------
; Kommando ^
; Einschalten einer Bank und Sprung ins Z9001-WBOOT
; Aufruf: ^ [bank]
;------------------------------------------------------------------------------

cmd_bank:	ld	a, (fcb1+1)		; folgt Parameter?
		cp	' '
		ld	a, standard_bank
		jr	z, cmd_bank1		; nein -> Std.-Bank 55 nehmen

		rst	20h			; Bank holen
		db 19h				; PARH2, 1 Byte hexadezimal aus Kommandozeile in Register E holen
		ret	c			; bei Fehler
		ld	a, e

cmd_bank1:	ld	hl, WBOOT		; Z9001-Warmstart, 0F003h
		jp	sys_jphl		; und Start mit Bankumschaltung

;------------------------------------------------------------------------------
; Kommando $CCP
; Kaltstartinitialisierung Modul CCP
;------------------------------------------------------------------------------

cmd_i_ccp:	
		; Eintragen der UP-Kommandos in UP-Tabelle
		ld	a, (sys_bank)
		ld	c, 28h			; NPAR
		ld	de, sub_npar
		rst	20h
		db 0FFh				; EXTUP, Einbindung eines weiteren Unterprogrammes in das System UP
		ret	c			; bei Fehler
		
		ld	c, 29h			; PARA
		ld	de, sub_para
		rst	20h
		db 0FFh				; EXTUP, Einbindung eines weiteren Unterprogrammes in das System UP
		ret	c			; bei Fehler
		
		ld	c, 2Ah			; KMOVE
		ld	de, sub_kmove
		rst	20h
		db 0FFh				; EXTUP, Einbindung eines weiteren Unterprogrammes in das System UP
		ret	c			; bei Fehler
		ret

;------------------------------------------------------------------------------
; 29 PARA , Parameter ab (DE) als Dateibezeichnung interpretieren und ab (HL) eintr.
;------------------------------------------------------------------------------

sub_para:	push	bc
sub_para1:	ld	a, (de)
		inc	de
		cp	' '
		jr	z, sub_para1
		or	a
		jr	z, sub_para2
		sub	'@'
		jr	c, sub_para2
		ld	b, a
		ld	a, (de)
		cp	':'
		jr	nz, sub_para2
		inc	de
		ld	(hl), b
		jr	sub_para3
sub_para2:	dec	de
		ld	(hl), 0
sub_para3:	inc	hl
		ld	b, 8
		call	sub_0_D411
		jr	c, sub_para9
		ld	b, 3
		cp	'.'
		jr	nz, sub_para4
		call	sub_0_D411
		jr	c, sub_para9
		jr	sub_para5
sub_para4:	ld	(hl), ' '
		inc	hl
		djnz	sub_para4
sub_para5:	ld	b, 3
sub_para6:	ld	(hl), 0
		inc	hl
		djnz	sub_para6
		ld	bc, 0FFF2h
		add	hl, bc
		ld	b, 0Bh
		ld	c, 0
sub_para7:	ld	a, (hl)
		cp	'?'
		jr	nz, sub_para8
		inc	c
sub_para8:	inc	hl
		djnz	sub_para7
		inc	hl
		inc	hl
		inc	hl
		inc	hl
		ld	a, c
		pop	bc
		or	a
		ret
;
sub_para9:	pop	bc
		ld	a, 1
		ret


sub_0_D411:	ld	a, (de)
		inc	de
		call	sub_0_D43C
		jr	nz, loc_0_D41F
loc_0_D418:	ld	(hl), ' '
		inc	hl
		djnz	loc_0_D418
		jr	loc_0_D438
loc_0_D41F:	cp	' '
		ret	c			; bei Fehler
		cp	'*'
		jr	nz, loc_0_D42D
loc_0_D426:	ld	(hl), '?'
		inc	hl
		djnz	loc_0_D426
		jr	loc_0_D431
loc_0_D42D:	ld	(hl), a
		inc	hl
		djnz	sub_0_D411
loc_0_D431:	ld	a, (de)
		inc	de
		call	sub_0_D43C
		jr	nz, loc_0_D431
loc_0_D438:	or	a
		ret	nz
		dec	de
		ret

sub_0_D43C:	push	hl
		push	bc
		ld	hl, unk_0_D44A
		ld	bc, 8
		or	a
		cpir
		pop	bc
		pop	hl
		ret

unk_0_D44A:	db    0," =_.:<>"


;------------------------------------------------------------------------------
; 28 NPAR , 2 Parameter aus Kommandozeile ab 80H als Dateibezeichnung in FCB ab (5C) 
;------------------------------------------------------------------------------

sub_npar:	push	de
		push	hl
		ld	de, CONBU
		call	sub_kmove

		inc	de
		ld	hl, fcb1
		call	sub_para

		call	nc, sub_para

		pop	hl
		pop	de
		ret


;------------------------------------------------------------------------------
; 2A KMOVE, 1. Parameter der Kommandozeile (DE) wegschieben
;------------------------------------------------------------------------------

sub_kmove:	push	bc
		push	de
		push	hl
		ld	l, e
		ld	h, d
		ld	c, (hl)
sub_kmove1:	inc	de
		dec	c
		ld	a, (de)
		or	a
		jr	z, sub_kmove3
		cp	' '
		jr	z, sub_kmove1
sub_kmove2:	inc	de
		dec	c
		ld	a, (de)
		or	a
		jr	z, sub_kmove3
		cp	' '
		jr	nz, sub_kmove2
sub_kmove3:	inc	c
		ld	(hl), c
		inc	hl
		ex	de, hl
		ld	b, 0
		inc	bc
		ldir
		pop	hl
		pop	de
		pop	bc
		ret

;------------------------------------------------------------------------------
; Kommando LOAD
; Aufruf: LOAD ...
;------------------------------------------------------------------------------

cmd_load:	ld	a, (fcb1+1)
		cp	' '			; folgt Parameter?
		ld	a, 1			; Fehler "zu wenige Parameter eingegeben"
		scf				; raus wenn kein Parameter
		ret	z
;
		push	ix
		ld	ix, fcb1
		ld	a, (ix+9)		; hat Parameter Dateityp?
		cp	' '
		jr	nz, cmd_load1

		ld	(ix+9),	'C'		; wenn nicht, 'COM' einsetzen
		ld	(ix+0Ah), 'O'
		ld	(ix+0Bh), 'M'
cmd_load1:	ld	(ix+20h), 0
		pop	ix
		ld	de, fcb1
		ld	c, 0Fh
		rst	8
		ret	c			; bei Fehler
		inc	a
		jr	nz, cmd_load2
		ld	a, 0Dh
		scf
		ret

cmd_load2:	ld	de, 0E600h
cmd_load3:	push	de
		ld	c, 1Ah
		rst	8
		jr	c, cmd_load4
		ld	de, fcb1
		ld	c, 14h
		rst	8
cmd_load4:	pop	hl
		ret	c			; bei Fehler
		ld	de, 80h
		add	hl, de
		or	a
		ret	nz
		push	hl
		add	hl, de
		ex	de, hl
		ld	hl, (0036h)		; EOR
		inc	hl
		or	a
		sbc	hl, de
		pop	de
		jr	nc, cmd_load3
		ld	a, d
		and	0FEh
		cp	0E6h
		jr	z, cmd_load3
		ld	b, d
		ld	de, 300h
		jr	nc, cmd_load3
		ld	a, 0Ah
		ret

