###############################################################################
#
#	Produkt		: kVASy
#	Modul		: Datenbernahme
#	Sprache		: Perl
#	Funktion	: 
#
#	 1999 - 2003 SIV AG (Volker Pohlers)
#
#	Historie:	04.03.2003	by Volker Pohlers created
#			30.08.2011	IN|OUT (C); IMx; JPP
#
#	Stand:		$Id$
#
# $Log:$
#
###############################################################################

# SEHR buggy, nur als Arbeitshilfe, kein vollwertiges Programm !!!

$ARGV[0] ||= 'd:/user/pohlers/z9001/emon/test.asm';

$label='\w[\w0-9$]{1,4}\s*:';
$string=q(".*?"|'.*?');


open IN, "<$ARGV[0]";
while (<IN>) {
	chomp;
	if (/^;/) { print "$_\n"} # Kommentarzeile
	elsif (/^\s*$/) { print "$_\n"} # Leerzeile
	elsif (/^\s*($label)?\s*(\w+)(\s+([^;]*))?(;.*)?/o) { 
		#print "Zeile $_\n";
		#print "decod $1-$2-$4-$5\n";
		$labelname = $1;
		$code = uc $2;
		$parameter = $4; 
		$kommentar = $5; 
		
		$parameter =~ s/\s+$//;
		$kommentar =~ s/\s+$//;
		
		$_ = $code;
		$code = ";$code" if $code eq 'PN';
		$code = "DB", $parameter .= ' dup (?)' if $code eq 'BER';
		$code = "DW" if $code eq 'DA';
		$code = "CP" if $code eq 'CMP';
		
		$parameter =~ s/\bM\b/(HL)/g;
		$parameter =~ s/#/\$/g;

		$parameter =~ s/\bHY\b/IYU/g;	# z80undoc
		$parameter =~ s/\bLY\b/IYL/g;
		$parameter =~ s/\bHX\b/IXU/g;
		$parameter =~ s/\bLX\b/IXL/g;


		#$parameter =~ s/'/"/g if $code eq "DB";
		$parameter =~ s/'(.{2,}?)'/"$1"/g;	# '...' -> "..."

		$code = "JP" if $code eq 'JMP';

		$code = "EX", $parameter = q(AF, AF') if $code eq 'EXAF';


		$code = "JR", $parameter = "$1, $parameter" if $code =~ /^JR(Z|NZ|C|NC)/;
		$parameter =~ s/[+-]\$//g if $code =~ /^(JR|DJNZ)/;

		$code = "RET", $parameter = "$1" if $code =~ /^R(Z|NZ|C|NC|M|P)/;
		$code = "CALL", $parameter = "$1, $parameter" if $code =~ /^CA(Z|NZ|C|NC|M|P)/;
		$code = "JP", $parameter = "$1, $parameter" if $code =~ /^JP(Z|NZ|C|NC|M|P)/;

		$code = "IM", $parameter = "$1, $parameter" if $code =~ /^IM(\d)/;


		$parameter = "A, $parameter" if $code =~ /^(AND|ADC|ADD|CP)$/ and $parameter !~ /,/;
		
		if ($code =~ /^(IN)$/ and $parameter !~ /,/ ) {
			if ($parameter =~ /^[A-L]$/) {$parameter = "$parameter, (C)" } else { $parameter = "A, $parameter" }
		}

		#$parameter = "A, $parameter" if $code =~ /^(IN)$/ and $parameter !~ /,/ and $parameter =~ /\d+/;
		#$parameter = "$parameter, (C)" if $code =~ /^(IN)$/ and $parameter !~ /,/ and $parameter =~ /^[A-L]$/;

		if ($code =~ /^(OUT)$/ and $parameter !~ /,/ ) {
			if ($parameter =~ /^[A-L]$/) {$parameter = "(C), $parameter" } else { $parameter .= ", A" }
		}

		#$parameter .= ", A" if $code =~ /^(OUT)$/ and $parameter !~ /,/ and $parameter =~ /\d+/;
		#$parameter = "(C), $parameter" if $code =~ /^(OUT)$/ and $parameter !~ /,/ and $parameter =~ /^[A-L]$/;
		
		#todo in und out fr Register		
		
		print "$labelname\t$code\t$parameter\t$kommentar\n" ;
	} 
	else {print "????$_\n" };
	#last if $. > 300;
}

close IN;

