		cpu	z80

; EPROM D2 (27512), Bereich C000-DFFF, Bank 0x bis 7x

;orig
;Bank   ROM   Inhalt  
;0x   D2-0000..1FFF   Bascoder BAC87  
;1x   D2-2000..3FFF   Loader von BAC87 und CHESS, CHESS Teil 1  
;2x   D2-4000..5FFF   CHESS Teil 2  
;3x   D2-6000..7FFF   BITEX-Modul  
;4x   D2-8000..9FFF   IDAS-Modul (die ersten 8K, ohne ZM)  
;5x   D2-A000..BFFF   EDIT/ASM-Modul (die ersten 8K)  
;6x   D2-C000..DFFF   - frei -   
;7x   D2-E000..FFFF   BASIC-Modul (die ersten 8K)  
;
;vp
;d2 - 27512, D3 - 27256, D5 - 27128
;Bank   ROM   Inhalt  
;0x   D2-0000..1FFF   Bascoder BAC87  
;1x   D2-2000..3FFF   Loader von BAC87 und CHESS, CHESS Teil 1  
;2x   D2-4000..5FFF   CHESS Teil 2  
;3x   D2-6000..7FFF   BITEX-Modul
;4x   D2-8000..9FFF   IDAS-Modul (die ersten 8K, ohne ZM)  mit ZM	!!!!		
;5x   D2-A000..BFFF   EDIT/ASM-Modul (die ersten 8K)  
;6x   D2-C000..DFFF   ZSID (die ersten 8K)				!!!!
;7x   D2-E000..FFFF   BASIC-Modul (die ersten 8K)  


		org 0h
		binclude "BAC87.BIN"
	
		org 2000h
		binclude "D2-1X.BIN"
		org 2080h
		binclude "CHESS.BIN"
	
		org 6000h
		binclude "BITEX.BIN"

		org 8000h
		binclude "IDAS-1.BIN"

		org 0A000h
		binclude "ASM-1.BIN"

		org 0C000h
		binclude "ZSID-1.BIN"

		org 0E000h
		binclude "BASIC-1.BIN"

;Zwischenrume werden vom Assembler autom. mit 0ffh gefllt

		org 10000h-1
		db	0ffh
	
		end
