		cpu	z80

;D5 (27128), Bereich E000-E7FF, Bank x0 bis x7

;orig
;x0   D5-0000..07FF   Modul-System-Software  
;x1   D5-0800..0FFF   - frei -
;x2   D5-1000..17FF   - frei -
;x3   D5-1800..1FFF   - frei -
;x4   D5-2000..27FF   - frei -
;x5   D5-2800..2FFF   EDIT/ASM-Modul (die oberen 2K)  
;x6   D5-3000..37FF   BASIC-Modul (die oberen 2K)  
;x7   D5-3800..3FFF   BASIC-Modul (alternative obere 2K)  
		
;vp		
;x0   D5-0000..07FF   Modul-System-Software  
;x1   D5-0800..0FFF   BASIC-Modul (alternative obere 2K)  		!!!!
;x2   D5-1000..17FF   2K-Eprom-Modul (EPROM auf E400)			!!!!
;x3   D5-1800..1FFF   - frei -
;x4   D5-2000..27FF   IDAS/ZM obere 2K					!!!!
;x5   D5-2800..2FFF   EDIT/ASM-Modul (die oberen 2K)  			!!!!
;x6   D5-3000..37FF   ZSID (die oberen 2K)  				!!!!
;x7   D5-3800..3FFF   BASIC-Modul (die oberen 2K) 			!!!!
		
		org 0000h
		binclude "D5-X0.BIN"
	
		org 0800h
		binclude "BASIC-2LE.BIN"

		org 1000h
		binclude "EPROM.BIN"

		org 1800h
		;frei

		org 2000h
		binclude "IDAS-2.BIN"

		org 2800h
		binclude "ASM-2.BIN"

		org 3000h
		binclude "ZSID-2.BIN"

		org 3800h
		binclude "BASIC-2.BIN"
	
;Zwischenrume werden vom Assembler autom. mit 0ffh gefllt
		org 4000h-1
		db	0ffh
	
		end
